//#include <bits/stdc++.h>
#include <iostream>
#include <vector>
#include <algorithm>
//#define int long long
#define ll long long
#define ld long double
#define F first
#define S second
using namespace std;
const int H = (1 << 15);
const int HA = (1 << 8);
const int HAA = (1 << 7);
ll dp1[HAA][H], dp2[HA][H];

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int h, w;
    cin >> h >> w;
    ll sum = 0;
    vector<vector<ll>> sumst(w, vector<ll>(h + 1)), sumsr(h, vector<ll>(w + 1));
    vector<vector<int>> a(h, vector<int>(w));
    bool e = 1;
    for (int i = 0; i < h; ++i) {
        for (int j = 0; j < w; ++j) {
            cin >> a[i][j];
            sum += a[i][j];
            if (a[i][j] > 6) {
                e = 0;
            }
        }
    }
    for (int i = 0; i < h; ++i) {
        for (int j = 0; j < w; ++j) {
            sumsr[i][j + 1] = a[i][j] + sumsr[i][j];
        }
    }
    for (int i = 0; i < w; ++i) {
        for (int j = 0; j < h; ++j) {
            sumst[i][j + 1] = a[j][i] + sumst[i][j];
        }
    }
    ll s;
    cin >> s;
    ll need = sum - s;
    if (need < 0) {
        cout << "NO\n";
        return 0;
    }
    if (e) {
        for (int i = 0; i < (1 << h); ++i) {
            int x = 0;
            for (int j = 0; j < h; ++j) {
                if ((1 << j) & i) {
                    for (int k = 0; k < w; ++k) {
                        x += a[j][k];
                    }
                }
            }
            if (x > need) {
                continue;
            }
            vector<int> st(w);
            for (int j = 0; j < w; ++j) {
                for (int k = 0; k < h; ++k) {
                    if (!((1 << k) & i)) {
                        st[j] += a[k][j];
                    }
                }
            }
            vector<vector<bool>> dp(w + 1, vector<bool>(need - x + 1, 0));
            vector<vector<int>> pred(w + 1, vector<int>(need - x + 1, -1));
            dp[0][0] = 1;
            pred[0][0]=0;
            for (int j = 0; j < w; ++j) {
                dp[j + 1] = dp[j];
                pred[j + 1] = pred[j];
                for (int k = need - x + 1 - st[j] - 1; k >= 0; --k) {
                    if (dp[j][k]) {
                        dp[j + 1][k + st[j]] = 1;
                        pred[j + 1][k + st[j]] = j + 1;
                    }
                }
            }
            if (dp[w][need - x]) {
                cout << "YES\n";
                vector<pair<int, int>> ans;
                for (int j = 0; j < h; ++j) {
                    if (i & (1 << j)) {
                        ans.push_back({1, j + 1});
                    }
                }
                int last = w;
                int p = need - x;
                while (p != 0) {
                    if (pred[last][p] == last) {
                        ans.push_back({2, last});
                        p -= st[last - 1];
                    }
                    last--;
                }
                cout << ans.size() << '\n';
                for (auto j: ans) {
                    cout << j.F << " " << j.S << '\n';
                }
                return 0;
            }
        }
        cout << "NO\n";
        return 0;
    }
    vector<vector<int>> ones((1 << 15));
    for (int i = 0; i < (1 << 15); ++i) {
        for (int j = 0; j < 15; ++j) {
            if ((1 << j) & i) {
                ones[i].push_back(j);
            }
        }
    }
    int half = w / 2;
    for (int i = 0; i < (1 << half); ++i) {
        ll o = 0;
        for (int k: ones[i]) {
            o += sumst[k][h];
        }
        for (int j = 0; j < (1 << h); ++j) {
            ll x = o;
            for (int l: ones[j]) {
                x += sumsr[l][half];
            }
            for (int k: ones[j]) {
                for (int l: ones[i]) {
                    x -= a[k][l];
                }
            }
            dp1[i][j] = x;
        }
    }
    for (int i = 0; i < (1 << (w - half)); ++i) {
        ll o = 0;
        for (int k: ones[i]) {
            o += sumst[k + half][h];
        }
        for (int j = 0; j < (1 << h); ++j) {
            ll x = o;
            for (int l: ones[j]) {
                x += sumsr[l][w] - sumsr[l][half];
            }
            for (int k: ones[j]) {
                for (int l: ones[i]) {
                    x -= a[k][l + half];
                }
            }
            dp2[i][j] = x;
        }
    }
    vector<vector<pair<ll, int>>> mp(1 << h);
    for (int i = 0; i < (1 << (w - half)); ++i) {
        for (int j = 0; j < (1 << h); ++j) {
            mp[j].push_back({dp2[i][j], i});
        }
    }
    for (int i = 0; i < (1 << h); ++i) {
        stable_sort(mp[i].begin(), mp[i].end());
    }
    for (int i = 0; i < (1 << half); ++i) {
        for (int j = 0; j < (1 << h); ++j) {
            if (dp1[i][j] > need) {
                continue;
            }
            int id = lower_bound(mp[j].begin(), mp[j].end(), make_pair(need - dp1[i][j], -1)) - mp[j].begin();
            if (id != mp[j].size() && mp[j][id].F == need - dp1[i][j]) {
                int msk = mp[j][id].S;
                cout << "YES\n";
                vector<pair<int, int>> ans;
                for (int k = 0; k < h; ++k) {
                    if (j & (1 << k)) {
                        ans.push_back({1, k + 1});
                    }
                }
                for (int k = 0; k < half; ++k) {
                    if (i & (1 << k)) {
                        ans.push_back({2, k + 1});
                    }
                }
                for (int k = 0; k < w - half; ++k) {
                    if (msk & (1 << k)) {
                        ans.push_back({2, k + half + 1});
                    }
                }
                cout << ans.size() << '\n';
                for (auto op: ans) {
                    cout << op.F << " " << op.S << '\n';
                }
                return 0;
            }
        }
    }
    cout << "NO";
    return 0;
}