#include <bits/stdc++.h>

//#define int long long
#define ld long double
#define F first
#define S second
using namespace std;
int n, q;
int maxn;

int maxpow2(int x) {
    int y = 1;
    while (y < x) {
        y *= 2;
    }
    return y;
}

vector<pair<int, int>> lr;
vector<pair<int, int>> tr;

void push(int v) {
    if (tr[v].S == -2) {
        return;
    }
    tr[v * 2].S = tr[v * 2 + 1].S = tr[v * 2].F = tr[v * 2 + 1].F = tr[v].S;
    tr[v].S = -2;
}

void upd(int v, int lv, int rv, int l, int r, int x) {
    push(v);
    if (lv >= l && rv <= r) {
        tr[v].S = tr[v].F = x;
        return;
    }
    if (lv >= r || rv <= l) {
        return;
    }
    int mid = (lv + rv) / 2;
    upd(v * 2, lv, mid, l, r, x);
    upd(v * 2 + 1, mid, rv, l, r, x);
    tr[v].S = -2;
}

int getel(int v, int lv, int rv, int id) {
    push(v);
    if (lv + 1 == rv) {
        return tr[v].F;
    }
    int mid = (lv + rv) / 2;
    if (id < mid) {
        return getel(v * 2, lv, mid, id);
    }
    return getel(v * 2 + 1, mid, rv, id);
}

vector<int> sz;
vector<int> par;

void dfs(int v, int p) {
    sz[v] = 1;
    par[v] = p;
    if (lr[v].F != -1) {
        dfs(lr[v].F, v);
        sz[v] += sz[lr[v].F];
    }
    if (lr[v].S != -1) {
        dfs(lr[v].S, v);
        sz[v] += sz[lr[v].S];
    }
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> q;
    lr.resize(n);
    maxn = maxpow2(n);
    sz.resize(n, 0);
    par.resize(n, 0);
    tr.resize(maxn * 2, {-1, -2});
    for (int i = 0; i < n; ++i) {
        cin >> lr[i].F >> lr[i].S;
        lr[i].F--;
        lr[i].S--;
    }
    dfs(0, -1);
    while (q--) {
        int t;
        cin >> t;
        if (t == 1) {
            int l, r, x;
            cin >> l >> r >> x;
            upd(1, 0, maxn, l - 1, r, x);
            //cout << ")"<<endl;
        } else {
            int id;
            cin >> id;
            id--;
            int now;
            int u = getel(1, 0, maxn, id);
            if (u == -1) {
                now = 1;
            } else if (u == 0) {
                now = 1;
                if (lr[id].F != -1) {
                    now += sz[lr[id].F];
                }
            } else {
                now = sz[id];
            }
            int last = id;
            id = par[id];
            while (id != -1) {
                int u = getel(1, 0, maxn, id);
                if (u == -1) {
                    if (lr[id].F == last) {
                        now++;
                    } else {
                        now++;
                        if (lr[id].F != -1) {
                            now += sz[lr[id].F];
                        }
                    }
                } else if (u == 0) {
                    if (lr[id].S == last) {
                        now++;
                        if (lr[id].F != -1) {
                            now += sz[lr[id].F];
                        }
                    }
                } else {
                    if (lr[id].S == last) {
                        if (lr[id].F != -1) {
                            now += sz[lr[id].F];
                        }
                    }
                }
                last = id;
                id = par[id];
            }
            cout << now << endl;
        }
    }
    return 0;
}
//5 5
//3 4
//0 0
//5 2
//0 0
//0 0
//2 2
//1 1 3 1
//2 5
//1 3 3 0
//2 3