#include <bits/stdc++.h>

//#define int long long
#define ld long double
#define F first
#define S second
using namespace std;
int n, q;
vector<pair<int, int>> lr;
vector<int> sz;
vector<int> par;

void dfs(int v, int p) {
    sz[v] = 1;
    par[v] = p;
    if (lr[v].F != -1) {
        dfs(lr[v].F, v);
        sz[v] += sz[lr[v].F];
    }
    if (lr[v].S != -1) {
        dfs(lr[v].S, v);
        sz[v] += sz[lr[v].S];
    }
}

vector<int> col;

vector<int> a;

void build(int v) {
    if (v == -1) {
        return;
    }
    if (col[v] == -1) {
        a.push_back(v);
        build(lr[v].F);
        build(lr[v].S);
    } else if (col[v] == 0) {
        build(lr[v].F);
        a.push_back(v);
        build(lr[v].S);
    } else {
        build(lr[v].F);
        build(lr[v].S);
        a.push_back(v);
    }
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> q;
    lr.resize(n);
    sz.resize(n, 0);
    par.resize(n, 0);
    col.resize(n, -1);
    for (int i = 0; i < n; ++i) {
        cin >> lr[i].F >> lr[i].S;
        lr[i].F--;
        lr[i].S--;
    }
    dfs(0, -1);
    int cn = 0;
    vector<vector<int>> qs(q);
    for (int i = 0; i < q; ++i) {
        int t;
        cin >> t;
        qs[i].push_back(t);
        if (t == 1) {
            cn++;
            for (int j = 0; j < 3; ++j) {
                int x;
                cin >> x;
                qs[i].push_back(x);
            }
        } else {
            int x;
            cin >> x;
            qs[i].push_back(x);
        }
    }
    build(0);
    vector<int> now = a;
    if (cn > 10) {
        for (auto o: qs) {
            if (o[0] == 1) {
                int l = o[1], r = o[2], x = o[3];
                for (int i = l - 1; i < r; ++i) {
                    col[i] = x;
                }
            } else {
                int id = o[1];
                id--;
                int now;
                int u = col[id];
                if (u == -1) {
                    now = 1;
                } else if (u == 0) {
                    now = 1;
                    if (lr[id].F != -1) {
                        now += sz[lr[id].F];
                    }
                } else {
                    now = sz[id];
                }
                int last = id;
                id = par[id];
                while (id != -1) {
                    u = col[id];
                    if (u == -1) {
                        if (lr[id].F == last) {
                            now++;
                        } else {
                            now++;
                            if (lr[id].F != -1) {
                                now += sz[lr[id].F];
                            }
                        }
                    } else if (u == 0) {
                        if (lr[id].S == last) {
                            now++;
                            if (lr[id].F != -1) {
                                now += sz[lr[id].F];
                            }
                        }
                    } else {
                        if (lr[id].S == last) {
                            if (lr[id].F != -1) {
                                now += sz[lr[id].F];
                            }
                        }
                    }
                    last = id;
                    id = par[id];
                }
                cout << now << '\n';
            }
        }
    } else {
        vector<int> rev(n);
        for (int i = 0; i < n; ++i) {
            rev[now[i]] = i;
        }
        for (auto o: qs) {
            if (o[0] == 1) {
                int l = o[1], r = o[2], x = o[3];
                for (int i = l - 1; i < r; ++i) {
                    col[i] = x;
                }
                a.clear();
                build(0);
                now = a;
                for (int i = 0; i < n; ++i) {
                    rev[now[i]] = i;
                }
            } else {
                int id = o[1];
                id--;
                cout << rev[id] + 1 << '\n';
            }
        }
    }
    return 0;
}
//5 5
//3 4
//0 0
//5 2
//0 0
//0 0
//2 2
//1 1 3 1
//2 5
//1 3 3 0
//2 3