#include <bits/stdc++.h>

//#define int long long
#define ld long double
#define F first
#define S second
using namespace std;
int n, q;
vector<pair<int, int>> lr;
vector<int> sz;
vector<int> par;
vector<pair<int, int>> tr;
int maxn;

int maxpow2(int x) {
    int y = 1;
    while (y < x) {
        y *= 2;
    }
    return y;
}

void push(int v) {
    if (v >= maxn || tr[v].S == -2) {
        return;
    }
    tr[v * 2].F = tr[v * 2 + 1].F = tr[v * 2].S = tr[v * 2 + 1].S = tr[v].S;
    tr[v].S = -2;
}

void upd(int v, int lv, int rv, int l, int r, int x) {
    push(v);
    if (lv >= l && rv <= r) {
        tr[v].S = tr[v].F = x;
        return;
    }
    if (lv >= r || rv <= l) {
        return;
    }
    int mid = (lv + rv) / 2;
    upd(v * 2, lv, mid, l, r, x);
    upd(v * 2 + 1, mid, rv, l, r, x);
    tr[v].S = -2;
}

int getel(int v, int lv, int rv, int id) {
    push(v);
    if (lv + 1 == rv) {
        return tr[v].F;
    }
    int mid = (lv + rv) / 2;
    if (id < mid) {
        return getel(v * 2, lv, mid, id);
    }
    return getel(v * 2 + 1, mid, rv, id);
}

void dfs(int v, int p) {
    sz[v] = 1;
    par[v] = p;
    if (lr[v].F != -1) {
        dfs(lr[v].F, v);
        sz[v] += sz[lr[v].F];
    }
    if (lr[v].S != -1) {
        dfs(lr[v].S, v);
        sz[v] += sz[lr[v].S];
    }
}

vector<int> col;

vector<int> a;

void build(int v) {
    if (v == -1) {
        return;
    }
    if (col[v] == -1) {
        a.push_back(v);
        build(lr[v].F);
        build(lr[v].S);
    } else if (col[v] == 0) {
        build(lr[v].F);
        a.push_back(v);
        build(lr[v].S);
    } else {
        build(lr[v].F);
        build(lr[v].S);
        a.push_back(v);
    }
}

void push1(int v) {
    if (v >= maxn || tr[v].S == 0) {
        return;
    }
    tr[v * 2].F += tr[v].S;
    tr[v * 2 + 1].F += tr[v].S;
    tr[v * 2].S += tr[v].S;
    tr[v * 2 + 1].S += tr[v].S;
    tr[v].S = 0;
}

void updplus(int v, int lv, int rv, int l, int r, int x) {
    push1(v);
    if (lv >= l && rv <= r) {
        tr[v].F += x;
        tr[v].S += x;
        return;
    }
    if (lv >= r || rv <= l) {
        return;
    }
    int mid = (lv + rv) / 2;
    updplus(v * 2, lv, mid, l, r, x);
    updplus(v * 2 + 1, mid, rv, l, r, x);
}

int getelement(int v, int lv, int rv, int id) {
    push1(v);
    if (lv + 1 == rv) {
        return tr[v].F;
    }
    int mid = (lv + rv) / 2;
    if (id < mid) {
        return getelement(v * 2, lv, mid, id);
    }
    return getelement(v * 2 + 1, mid, rv, id);
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> q;
    maxn = maxpow2(n);
    tr.resize(maxn * 2, {-1, -2});
    lr.resize(n);
    sz.resize(n, 0);
    par.resize(n, 0);
    col.resize(n, -1);
    for (int i = 0; i < n; ++i) {
        cin >> lr[i].F >> lr[i].S;
        lr[i].F--;
        lr[i].S--;
    }
    dfs(0, -1);
    int cn = 0;
    int lq = -1;
    bool e = 1;
    bool f = 1;
    vector<vector<int>> qs(q);
    for (int i = 0; i < q; ++i) {
        int t;
        cin >> t;
        if (t == 1 && lq == 2) {
            e = 0;
        }
        lq = t;
        qs[i].push_back(t);
        if (t == 1) {
            cn++;
            for (int j = 0; j < 3; ++j) {
                int x;
                cin >> x;
                qs[i].push_back(x);
            }
            if (qs[i][1] != qs[i][2]) {
                f = 0;
            }
        } else {
            int x;
            cin >> x;
            qs[i].push_back(x);
        }
    }
    build(0);
    vector<int> now = a;
    if (f) {
        vector<int> ids(n);
        for (int i = 0; i < n; ++i) {
            ids[now[i]] = i;
        }
        for (int i = 0; i < n; ++i) {
            tr[i + maxn].F = i;
        }
        for (int i = 0; i < maxn * 2; ++i) {
            tr[i].S = 0;
        }
        for (auto o: qs) {
            if (o[0] == 1) {
                int l = o[1], r = o[2], x = o[3];
                l--;
                r--;
                if (col[l] == x) {
                    continue;
                }
                if (x == -1) {
                    if (col[l] == 1) {
                        updplus(1, 0, maxn, ids[l] + 1, ids[l] + sz[l], 1);
                        updplus(1, 0, maxn, ids[l], ids[l] + 1, -sz[l] + 1);
                    } else {
                        int sss = 0;
                        if (lr[l].F != -1) {
                            sss = sz[lr[l].F];
                        }
                        updplus(1, 0, maxn, ids[l] + 1, ids[l] + sss + 1, 1);
                        updplus(1, 0, maxn, ids[l], ids[l] + 1, -sss);
                    }
                } else if (x == 0) {
                    if (col[l] == 1) {
                        int sss = 0;
                        if (lr[l].F != -1) {
                            sss = sz[lr[l].F];
                        }
                        updplus(1, 0, maxn, ids[l] + sss + 1, ids[l] + sz[l], 1);
                        updplus(1, 0, maxn, ids[l], ids[l] + 1, -(sz[l] - sss - 1));
                    } else {
                        int sss = 0;
                        if (lr[l].F != -1) {
                            sss = sz[lr[l].F];
                        }
                        updplus(1, 0, maxn, ids[l] + 1, ids[l] + sss + 1, -1);
                        updplus(1, 0, maxn, ids[l], ids[l] + 1, sss);
                    }
                } else {
                    if (col[l] == 0) {
                        int sss = 0;
                        if (lr[l].F != -1) {
                            sss = sz[lr[l].F];
                        }
                        updplus(1, 0, maxn, ids[l] + sss + 1, ids[l] + sz[l], -1);
                        updplus(1, 0, maxn, ids[l], ids[l] + 1, (sz[l] - sss - 1));
                    } else {
                        updplus(1, 0, maxn, ids[l] + 1, ids[l] + sz[l], -1);
                        updplus(1, 0, maxn, ids[l], ids[l] + 1, sz[l] - 1);
                    }
                }
                col[l] = x;
            } else {
                int id = o[1];
                id--;
                int pp = ids[id];
                cout << getelement(1, 0, maxn, pp) + 1 << '\n';
            }
        }
    } else if (e) {
        now.clear();
        vector<int> rev(n);
        for (auto o: qs) {
            if (o[0] == 1) {
                int l = o[1], r = o[2], x = o[3];
                upd(1, 0, maxn, l - 1, r, x);
            } else {
                int id = o[1];
                id--;
                if (now.empty()) {
                    a.clear();
                    for (int i = 0; i < n; ++i) {
                        col[i] = getel(1, 0, maxn, i);
                    }
                    build(0);
                    now = a;
                    for (int i = 0; i < n; ++i) {
                        rev[now[i]] = i;
                    }
                }
                cout << rev[id] + 1 << '\n';
            }
        }
    } else if (cn > 10) {
        for (auto o: qs) {
            if (o[0] == 1) {
                int l = o[1], r = o[2], x = o[3];
                for (int i = l - 1; i < r; ++i) {
                    col[i] = x;
                }
            } else {
                int id = o[1];
                id--;
                int now;
                int u = col[id];
                if (u == -1) {
                    now = 1;
                } else if (u == 0) {
                    now = 1;
                    if (lr[id].F != -1) {
                        now += sz[lr[id].F];
                    }
                } else {
                    now = sz[id];
                }
                int last = id;
                id = par[id];
                while (id != -1) {
                    u = col[id];
                    if (u == -1) {
                        if (lr[id].F == last) {
                            now++;
                        } else {
                            now++;
                            if (lr[id].F != -1) {
                                now += sz[lr[id].F];
                            }
                        }
                    } else if (u == 0) {
                        if (lr[id].S == last) {
                            now++;
                            if (lr[id].F != -1) {
                                now += sz[lr[id].F];
                            }
                        }
                    } else {
                        if (lr[id].S == last) {
                            if (lr[id].F != -1) {
                                now += sz[lr[id].F];
                            }
                        }
                    }
                    last = id;
                    id = par[id];
                }
                cout << now << '\n';
            }
        }
    } else {
        vector<int> rev(n);
        for (int i = 0; i < n; ++i) {
            rev[now[i]] = i;
        }
        for (auto o: qs) {
            if (o[0] == 1) {
                int l = o[1], r = o[2], x = o[3];
                for (int i = l - 1; i < r; ++i) {
                    col[i] = x;
                }
                a.clear();
                build(0);
                now = a;
                for (int i = 0; i < n; ++i) {
                    rev[now[i]] = i;
                }
            } else {
                int id = o[1];
                id--;
                cout << rev[id] + 1 << '\n';
            }
        }
    }
    return 0;
}
//3 3
//2 0
//3 0
//0 0
//2 2
//1 2 2 1
//2 2