#include <bits/stdc++.h>

#define int long long
#define ld long double
#define F first
#define S second
using namespace std;

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int h, w;
    cin >> h >> w;
    int sum = 0;
    vector<vector<int>> a(h, vector<int>(w));
    for (int i = 0; i < h; ++i) {
        for (int j = 0; j < w; ++j) {
            cin >> a[i][j];
            sum += a[i][j];
        }
    }
    int s;
    cin >> s;
    int need = sum - s;
    if (h + w <= 16) {
        for (int i = 0; i < (1 << h); ++i) {
            for (int j = 0; j < (1 << w); ++j) {
                int x = 0;
                for (int k = 0; k < w; ++k) {
                    for (int l = 0; l < h; ++l) {
                        if (((1 << k) & j) || ((1 << l) & i)) {
                            x += a[l][k];
                        }
                    }
                }
                if (x == need) {
                    cout << "YES\n";
                    vector<pair<int, int>> ans;
                    for (int k = 0; k < h; ++k) {
                        if ((1 << k) & i) {
                            ans.push_back({1, k + 1});
                        }
                    }
                    for (int k = 0; k < w; ++k) {
                        if ((1 << k) & j) {
                            ans.push_back({2, k + 1});
                        }
                    }
                    cout << ans.size() << '\n';
                    for (auto op: ans) {
                        cout << op.F << " " << op.S << '\n';
                    }
                    return 0;
                }
            }
        }
        cout << "NO\n";
        return 0;
    }
    int half = w / 2;
    vector<vector<int>> dp1((1 << half), vector<int>((1 << h)));
    vector<vector<int>> dp2((1 << (w - half)), vector<int>((1 << h)));
    for (int i = 0; i < (1 << half); ++i) {
        for (int j = 0; j < (1 << h); ++j) {
            int x = 0;
            for (int k = 0; k < half; ++k) {
                for (int l = 0; l < h; ++l) {
                    if (((1 << k) & i) || ((1 << l) & j)) {
                        x += a[l][k];
                    }
                }
            }
            dp1[i][j] = x;
        }
    }
    for (int i = 0; i < (1 << (w - half)); ++i) {
        for (int j = 0; j < (1 << h); ++j) {
            int x = 0;
            for (int k = 0; k < w - half; ++k) {
                for (int l = 0; l < h; ++l) {
                    if (((1 << k) & i) || ((1 << l) & j)) {
                        x += a[l][k + half];
                    }
                }
            }
            dp2[i][j] = x;
        }
    }
    vector<map<int, int>> mp(1 << h);
    for (int i = 0; i < (1 << (w - half)); ++i) {
        for (int j = 0; j < (1 << h); ++j) {
            mp[j][dp2[i][j]] = i;
        }
    }
    for (int i = 0; i < (1 << half); ++i) {
        for (int j = 0; j < (1 << h); ++j) {
            if (dp1[i][j] > need) {
                continue;
            }
            if (mp[j].count(need - dp1[i][j])) {
                int msk = mp[j][need - dp1[i][j]];
                cout << "YES\n";
                vector<pair<int, int>> ans;
                for (int k = 0; k < h; ++k) {
                    if (j & (1 << k)) {
                        ans.push_back({1, k + 1});
                    }
                }
                for (int k = 0; k < half; ++k) {
                    if (i & (1 << k)) {
                        ans.push_back({2, k + 1});
                    }
                }
                for (int k = 0; k < w - half; ++k) {
                    if (msk & (1 << k)) {
                        ans.push_back({2, k + half + 1});
                    }
                }
                cout << ans.size() << '\n';
                for (auto op: ans) {
                    cout << op.F << " " << op.S << '\n';
                }
                return 0;
            }
        }
    }
    cout << "NO";
    return 0;
}